/**
 * Funes relativas  detalhes de interface web.
 * @author FLevy
 * @version 28/01/2012
 */
var CARTA_VERSO = "images/verso-azul.png";
var FICHA_SUFIXO = "-ficha";
var IMAGEM_DIRETORIO = "images/";
var IMAGEM_EXTENSAO = ".png";

var FICHAS = {
	"1" : new Image(43, 30),
	"2" : new Image(43, 36),
	"3" : new Image(43, 42),
	"4" : new Image(43, 48),
	"5" : new Image(43, 54)
}

var CARTAS = {
	"2-P" : new Image(75, 108),
	"3-P" : new Image(75, 108),
	"4-P" : new Image(75, 108),
	"5-P" : new Image(75, 108),
	"6-P" : new Image(75, 108),
	"7-P" : new Image(75, 108),
	"8-P" : new Image(75, 108),
	"9-P" : new Image(75, 108),
	"10-P" : new Image(75, 108),
	"J-P" : new Image(75, 108),
	"Q-P" : new Image(75, 108),
	"K-P" : new Image(75, 108),
	"A-P" : new Image(75, 108),
	"2-C" : new Image(75, 108),
	"3-C" : new Image(75, 108),
	"4-C" : new Image(75, 108),
	"5-C" : new Image(75, 108),
	"6-C" : new Image(75, 108),
	"7-C" : new Image(75, 108),
	"8-C" : new Image(75, 108),
	"9-C" : new Image(75, 108),
	"10-C" : new Image(75, 108),
	"J-C" : new Image(75, 108),
	"Q-C" : new Image(75, 108),
	"K-C" : new Image(75, 108),
	"A-C" : new Image(75, 108),
	"2-E" : new Image(75, 108),
	"3-E" : new Image(75, 108),
	"4-E" : new Image(75, 108),
	"5-E" : new Image(75, 108),
	"6-E" : new Image(75, 108),
	"7-E" : new Image(75, 108),
	"8-E" : new Image(75, 108),
	"9-E" : new Image(75, 108),
	"10-E" : new Image(75, 108),
	"J-E" : new Image(75, 108),
	"Q-E" : new Image(75, 108),
	"K-E" : new Image(75, 108),
	"A-E" : new Image(75, 108),
	"2-O" : new Image(75, 108),
	"3-O" : new Image(75, 108),
	"4-O" : new Image(75, 108),
	"5-O" : new Image(75, 108),
	"6-O" : new Image(75, 108),
	"7-O" : new Image(75, 108),
	"8-O" : new Image(75, 108),
	"9-O" : new Image(75, 108),
	"10-O" : new Image(75, 108),
	"J-O" : new Image(75, 108),
	"Q-O" : new Image(75, 108),
	"K-O" : new Image(75, 108),
	"A-O" : new Image(75, 108)
};

/**
 * Carrega as imagens antecipadamente. Evita que a imagem no aparea quando necessrio.
 */
jQuery(document).ready(function(){
	// Cartas
	for (var key in CARTAS) {
		CARTAS[key].src = IMAGEM_DIRETORIO + key + IMAGEM_EXTENSAO;
	}
	
	// Fichas
	for (var key in FICHAS) {
		FICHAS[key].src = IMAGEM_DIRETORIO + key + FICHA_SUFIXO + IMAGEM_EXTENSAO;
	}
});

 /**
  * Habilita a mscara de fundo usada por uma popup.
  */
function habilitaMascara() {
	jQuery('body').css('overflow','hidden');
	
	//Set height and width to mask to fill up the whole screen  
	jQuery('#popup_mask').css('width', jQuery(window).width());
	jQuery('#popup_mask').css('height', jQuery(document).height());  
	jQuery('#popup_mask').css('opacity','0.4');
	jQuery('#popup_mask').show(); 
}

/**
  * Desabilita a mscara de fundo usada por uma popup.
  */
function desabilitaMascara() {
	jQuery('body').css('overflow','auto');
	jQuery('#popup_mask').hide(); 
}

/**
 * Popup de erro
 */
jQuery(document).ready(function(){
	jQuery("#erro").dialog({
		autoOpen: false,
		draggable: false,
		modal: true,
		closeText: 'X',
		zIndex: 9999,
		modal: true,
		hide: "fade",
		show: "fade",
		resizable: false,
		buttons: {
			Ok: function() {
				jQuery( this ).dialog( "close" );
			}
		},
		open: function(event, ui) {
			habilitaMascara();
		}, 
		close: function(event, ui) {
			desabilitaMascara();
		}
	});
});

/**
 * Slider de aposta
 */
jQuery(document).ready(function(){
	jQuery("#slider_aposta").slider({
		change: function(event, ui) {
			if (jQuery("#slider_aposta").slider("value") == jQuery("#slider_aposta").slider("option", "max" ))
				jQuery("#numero_fichas_aposta").text("All-in");
			else
				jQuery("#numero_fichas_aposta").text(jQuery("#slider_aposta").slider("value"));
		}
	})
});