/**
 * Funes gerais do jogo de pquer.
 * 
 * Detalhes:
 * - O jogador na posicao SUPERIOR  o computador.
 * @author FLevy
 * @date 11/02/2012
 */
 
// Coloque aqui os seus jars e as suas classes.
// Separe-os por vrgula.
// Exemplo:
//		se forem as classes na pasta "bin", coloque "bin\\"
//		se forem as classes na pasta "temp\algo", coloque "temp\\algo\\"
//		se for um jar "meujogodepoquer.jar" na pasta "jars", por exemplo, coloque "jars\\meujogodepoquer.jar"
var APPLET_ARCHIVE = "bin\\";
 
// Constantes
var TEMPO_ESPERA = 2000; // Tempo de espera para avisar ao Applet que a ao foi feita.
var TEMPO_BALAO = 1500; // Tempo que o balo de mensagem fica ativo.
var TEMPO_FLIP = 1000; // Tempo de flip de uma carta.
var TEMPO_MENSAGEM_VENCEU = 2500; // Tempo de aviso da mensagem de venceu a mo.
var TEMPO_MENSAGEM_COBRIR = 2000; // Tempo de aviso da mensagem de cobrir.
var NUMERO_DE_FOGOS = 8; // Nmero de fogos que aparece ao ganhar o jogo.

// Classe principal do Applet
var APPLET_CLASSE = "br.usp.poli.java.ihc.applet.AppletPoquer"; 

var jogo;
var nomeJogador = "";
var fichasSuperior, fichasInferior;
var fichasApostadasSuperior, fichasApostadasInferior;
var numeroDeAvisos = 0;
var mesaVazia = 0;

// Para o firefox no ficar reiniciando o applet aps um erro ao iniciaro applet.
var teveErro = false;
var omitirErros = false;

/**
 * Quando a pgina est pronta, cria o applet.
 * No  possvel colocar na pgina HTML diretamente pois algumas vezes o applet
 * carrega antes que a pgina e em outras, a pgina carrega antes que o applet.
 * Portanto no  possvel saber quando  possvel conversar com o applet.
 */
jQuery(document).ready(function(){
	var applet = document.createElement("applet");

	applet.id="applet_poquer";
	applet.appendChild(document.createTextNode("Desculpe, mas seu browser no suporta um Applet Java ou ele foi desabilitado por restries de segurana."));
	applet.setAttribute("code", APPLET_CLASSE);
	applet.setAttribute("archive", APPLET_ARCHIVE);
	applet.setAttribute("height", "1");
	applet.setAttribute("width", "1");
	
	document.body.appendChild(applet);
	
	setTimeout(function() { verificarAtivo(); }, 100);
});

/**
 * Verifica se o applet est ativo. Quando ativo, chama iniciar.
 */
function verificarAtivo() {
	if (teveErro) {
		omitirErros = true;
		return;
	}
	
	try {
		if (document.applet_poquer && document.applet_poquer.isActive()) {
			iniciar();
		} else {
			setTimeout(function() { verificarAtivo(); }, 100);
		}
	} catch (e) {
		// O Firefox joga um erro se no tiver carregado
		setTimeout(function() { verificarAtivo(); }, 100);
	}
}

/**
 * Apresenta o menu e as opes de escolha do jogo de poquer.
 */
function iniciar() {
	// pedindo os jogadores disponveis no Java
	var fechado = null;
	var texas = null;
	
	// Obtendo do applet os tipos de jogadores
	fechado = document.applet_poquer.getJogadoresDePoquerFechado();
	texas = document.applet_poquer.getJogadoresDeTexasHoldem();
	
	if ((fechado == null || fechado.length == 0) && (texas == null || texas.length ==0)) {
		erro("No existem jogadores disponveis.");
		return;
	} else if (texas == null || texas.length == 0) {
		jQuery("#menu_opcoes_texas").hide();
	}
	
	if (fechado == null || fechado.length == 0) {
		jQuery("#menu_opcoes_fechado").hide();
	} else {
		for (var i = 0; i < fechado.length; i++) {
			jQuery("#menu_jogadores_fechado").append(
				"<input type='radio' name='jogadorFechado' value='" + fechado[i] + "' id='jf" + i + "' />" +
				"<label for='jf" + i + "' accesskey='" + i + "'>" + fechado[i] + "</label>"+
				"<br />"
			);
		}
	}
	
	if (texas == null || texas.length == 0) {
		jQuery("#menu_opcoes_texas").hide();
	} else {
		for (var i = 0; i < fechado.length; i++) {
			jQuery("#menu_jogadores_texas").append(
				"<input type='radio' name='jogadorTexas' value='" + texas[i] + "' id='jt" + i + "' />" +
				"<label for='jt" + i + "' accesskey='" + i + "'>" + texas[i] + "</label>"+
				"<br />"
			);
		}
	}
	
	apresentarMenu();
}

/**
 * Apresenta o menu com as opes de jogo.
 */
function apresentarMenu() {
	// zerando tudo, caso seja necessrio
	jQuery("input[name='opcao_jogo']").prop("checked", false);
	jQuery("input[name='jogadorTexas']").prop("checked", false);
	jQuery("input[name='jogadorFechado']").prop("checked", false);
	jQuery("#opcao_texas").prop("checked", false);
	
	jQuery("#botao_ok").unbind("click");
	jQuery("#opcao_texas").unbind("change");
	jQuery("#opcao_fechado").unbind("change");
	jQuery("#nome_jogador").unbind("keyup");
	jQuery("#menu_jogadores").hide();
	
	// Radio button com a opo texas
	jQuery("#opcao_texas").change(function() {
		jQuery("#menu_jogadores").show();
		jQuery("#botao_ok").show();
		jQuery("#botao_ok").attr("disabled", "disabled");
		
		jQuery("input[name='jogadorTexas']").prop("checked", false);
		
		if (jQuery("#menu_jogadores_texas").is(':hidden')) {
			jQuery("#menu_jogadores_texas").show();
			jQuery("#menu_jogadores_fechado").hide();
			jQuery("input[name='jogadorTexas']").change(function(){
				if(jQuery(this).is(':checked') && jQuery("#nome_jogador").val().trim() != ""){ // if checked
					jQuery("#botao_ok").removeAttr("disabled");
				}
			});
		}
	});
	
	// Radio button com a opo fechado
	jQuery("#opcao_fechado").change(function() {
		jQuery("#menu_jogadores").show();
		jQuery("#botao_ok").show();
		jQuery("#botao_ok").attr("disabled", "disabled");
		
		jQuery("input[name='jogadorFechado']").prop("checked", false);
		
		if (jQuery("#menu_jogadores_fechado").is(":hidden")) {
			jQuery("#menu_jogadores_fechado").show();
			jQuery("#menu_jogadores_texas").hide();
			jQuery("input[name='jogadorFechado']").change(function(){
				if(jQuery(this).is(':checked') && jQuery("#nome_jogador").val().trim() != ""){ // if checked
					jQuery("#botao_ok").removeAttr("disabled");
				}
			});
		}
	});
	
	jQuery("#nome_jogador").keyup(function() {
		if(jQuery(this).val() != "" && (jQuery("input[name='jogadorFechado']").is(':checked') || jQuery("input[name='jogadorTexas']").is(':checked'))) {
			jQuery("#botao_ok").removeAttr("disabled");
		} else {
			jQuery("#botao_ok").attr("disabled", "disabled");
		}
	}).keyup();
	
	// Se clicar no boto, inicia o jogo
	jQuery("#botao_ok").click(function() {
		iniciarJogo();
	});
	
	jQuery("#menu").show();
	jQuery("#jogo").hide();
	jQuery("#area_poquer").fadeIn("slow");
}

/**
 * Comea o jogo de pquer com as opes selecionadas.
 */
function iniciarJogo() {
	jogo = jQuery("input[name='opcao_jogo']:checked").val(); // pegando a opo_jogo selecionada
	var jogador = (jogo == "texas")?jQuery("input[name='jogadorTexas']:checked").val():jQuery("input[name='jogadorFechado']:checked").val();
	nomeJogador = jQuery("#nome_jogador").val();
	
	if (jogo == "texas") {
		jQuery("#viradas").addClass("viradas_texas");
		jQuery("#viradas").show();
	} else {
		jQuery("#viradas").addClass("viradas_fechado");
		jQuery("#viradas").show();
	}
	
	jQuery("#nome_jogador_inferior").text(nomeJogador);
	
	if (!jQuery("#jogo").is(":visible")) {
		jQuery("#menu").hide();
		jQuery("#jogo").show();
	}
	
	// Colocando 10 fichas para cada 
	apresentarFichas("#fichas_superior", 10);
	fichasSuperior = 10;
	fichasApostadasSuperior = 0;
	apresentarFichas("#fichas_inferior", 10);
	fichasInferior = 10;
	fichasApostadasInferior = 0;
	
	mesaVazia = 0;
	// Chamando o applet
	document.getElementById("applet_poquer").iniciar(jogo, jogador, nomeJogador);
}

/**
 * (Mtodo chamado pelo Applet) Deposita as fichas ao iniciar uma rodada.
 * @param posicao A posio do jogador ("SUPERIOR" ou "INFERIOR").
 * @param fichas O nmero de fichas que o jogador depositou.
 */
function depositar(posicao, fichas) {
	if (mesaVazia >= 2) {
		// Algum deveria ter limpado a mesa...
		erro("A mesa no est limpa!\nOs jogadores no devem ter sido  avisados corretamente do fim da mo.");
	}
	
	if (posicao == "SUPERIOR") {
		fichasSuperior -= parseInt(fichas);
		fichasApostadasSuperior = parseInt(fichas);
		apresentarFichas("#fichas_superior", fichasSuperior);
		apresentarFichas("#aposta_superior", fichas);
		if (parseInt(fichas) == 1) {
			log("#aposta_superior", "Computador depositou 1 ficha.", "top");
		} else {
			log("#aposta_superior", "Computador depositou " + fichas + " fichas.", "top");
		}
	} else {
		fichasInferior -= parseInt(fichas);
		fichasApostadasInferior = parseInt(fichas);
		apresentarFichas("#fichas_inferior", fichasInferior);
		apresentarFichas("#aposta_inferior", fichas);
		if (parseInt(fichas) == 1) {
			log("#aposta_inferior", nomeJogador + " depositou 1 ficha.", "bottom");
		} else {
			log("#aposta_inferior", nomeJogador + " depositou " + fichas + " fichas.", "bottom");
		}
	}
	
	mesaVazia++;
	sleep(TEMPO_ESPERA);
}

/**
 * (Mtodo chamado pelo Applet) Mostra a aposta feita pelo computador.
 * @param fichas O nmero de fichas que o computador apostou.
 */
function mostrarAposta(fichas) {
	if (parseInt(fichas) > 0) {
		fichasSuperior -= parseInt(fichas);
		fichasApostadasSuperior += parseInt(fichas);
		apresentarFichas("#fichas_superior", fichasSuperior);
		apresentarFichas("#aposta_superior", fichasApostadasSuperior);
	}
	
	if (parseInt(fichas) < 0 || (fichasSuperior > 0 && fichasApostadasSuperior < fichasApostadasInferior)) {
		// ele fugiu...
		log("#nome_jogador_superior", "Computador fugiu.", "top");
	} else if (parseInt(fichas) == 0) {
		log("#nome_jogador_superior", "Computador passou.", "top");
	} else {
		if (parseInt(fichas) == 1) {
			log("#aposta_superior", "Computador apostou 1 ficha.", "top");
		} else {
			log("#aposta_superior", "Computador apostou " + fichas + " fichas.", "top");
		}
	}
	
	sleep(TEMPO_ESPERA);
}

/**
 * (Mtodo chamado pelo Applet) Avisa que o jogador recebeu cartas.
 * Tambm faz a apresentao para as cartas do adversrio.
 * @param cartas As cartas recebidas.
 */
function receberCartas(cartas) {
	var vetorCartas = cartas.split("|");
	
	// Apresentando cada uma das cartas dos jogadores
	if (jogo == "texas") {
		// Colocando as 5 cartas no centro da mesa
		for (var i = 0; i < 5; i++) {
			jQuery("#viradas").append("<img src='" + CARTA_VERSO + "' class='carta virada' width='75' height='108' id='carta_virada" + (i + 1) + "' />");
		}
		jQuery("img[id^='carta_virada']").fadeIn("slow");
	}
	
	// Jogador Superior
	jQuery("img[id^='carta_superior']").slice(0, vetorCartas.length).rotate3Di(0);
	jQuery("img[id^='carta_superior']").slice(0, vetorCartas.length).attr("src", CARTA_VERSO).fadeIn("slow");
	
	// Jogador inferior
	jQuery("img[id^='carta_inferior']").slice(0, vetorCartas.length).rotate3Di(0);
	jQuery("img[id^='carta_inferior']").slice(0, vetorCartas.length).attr("src", CARTA_VERSO).fadeIn("slow", function() {
		var posicao = parseInt(jQuery(this).attr("id").replace("carta_inferior", ""));
		
		if (posicao == vetorCartas.length) {
			jQuery("#carta_inferior" + posicao).rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
				jQuery(this).attr("src", CARTAS[vetorCartas[posicao - 1]].src);
				jQuery(this).attr("name", vetorCartas[posicao - 1]);
			}, complete: function() { sleep(TEMPO_ESPERA); }});
		} else {
			jQuery("#carta_inferior" + posicao).rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
				jQuery(this).attr("src", CARTAS[vetorCartas[posicao - 1]].src);
				jQuery(this).attr("name", vetorCartas[posicao - 1]);
			}});
		}
	});
}

/**
 * (Mtodo chamado pelo Applet) Pede para o jogador apostar.
 * @param fichasDisponiveis O nmero de fichas disponveis
 * @param valorDaApostaMinima O valor da aposta mnima.
 * @param pote O valor do pote atual.
 */
function pedirParaApostar (fichasDisponiveis, valorDaApostaMinima, pote) {
	// Desaparecendo com tudo
	jQuery("#opcoes_botoes").hide();
	jQuery("input[id^='botao_']").hide();
	jQuery("input[id^='botao_']").unbind("click");
	
	if (parseInt(valorDaApostaMinima) >= parseInt(fichasDisponiveis)) {
		// S mostra o boto all-in
		jQuery("#botao_allin").show();
		jQuery("#botao_allin").click({fichas: fichasDisponiveis}, function(e) {
			// Indo all-in
			fichasInferior = 0;
			fichasApostadasInferior += parseInt(e.data.fichas);
			
			// animando as fichas
			apresentarFichas("#fichas_inferior", fichasInferior);
			apresentarFichas("#aposta_inferior", fichasApostadasInferior);
			
			jQuery("#opcoes_botoes").fadeOut("slow");
			setTimeout(function() {
				document.getElementById("applet_poquer").getInterfaceHTML().apostar(e.data.fichas);
			}, TEMPO_ESPERA);
		});
	} else {
		// Permitindo o slider
		jQuery("#botao_apostar").click({ fichas: fichasDisponiveis, valor: valorDaApostaMinima, pote: pote}, function(e) {
			apostar(e.data.fichas, e.data.valor, e.data.pote);
		});
		jQuery("#botao_apostar").show();
	}
	
	if (parseInt(valorDaApostaMinima) == 0) {
		jQuery("#botao_passar").click(function() {
			jQuery("#opcoes_botoes").fadeOut("slow");
			setTimeout(function() {
				document.getElementById("applet_poquer").getInterfaceHTML().apostar(0);
			}, TEMPO_ESPERA);
		});
		jQuery("#botao_passar").show();
	}
	
	jQuery("#botao_fugir").click(function() {
		jQuery("#opcoes_botoes").fadeOut("slow");
		
		setTimeout(function() {
			document.getElementById("applet_poquer").getInterfaceHTML().apostar(-1);
		}, TEMPO_ESPERA);
	});
	jQuery("#botao_fugir").show();

	jQuery("#opcoes_botoes").fadeIn("slow");
}

/**
 * Permite que o usurio aposte um valor.
 * @param fichasDisponiveis O nmero de fichas que o jogador tem disponvel.
 * @param valorDaApostaMinima O valor da aposta mnima.
 * @param pote O nmero de fichas do pote atual.
 */
function apostar (fichasDisponiveis, valorDaApostaMinima, pote) {
	valorDaApostaMinima = parseInt(valorDaApostaMinima);
	
	jQuery("input[id^='botao_']").hide();
	jQuery("input[id^='botao_']").unbind("click");
	
	jQuery("#slider_aposta").slider({min: valorDaApostaMinima, max: fichasDisponiveis, value: valorDaApostaMinima});
	jQuery("#opcoes_aposta").fadeIn("slow");
	
	fichasInferior = parseInt(fichasDisponiveis);
	
	jQuery("#botao_confirmar").click(function() {
		var aposta = parseInt(jQuery("#slider_aposta").slider("value"));
		
		fichasInferior -= aposta;
		fichasApostadasInferior += aposta;
		
		jQuery("#opcoes_aposta").fadeOut("slow");
		jQuery("#opcoes_botoes").fadeOut("slow");
		
		// animando as fichas
		apresentarFichas("#fichas_inferior", fichasInferior);
		apresentarFichas("#aposta_inferior", fichasApostadasInferior);
		setTimeout(function() {
			document.getElementById("applet_poquer").getInterfaceHTML().apostar(aposta);
		}, TEMPO_ESPERA);
	});
	jQuery("#botao_confirmar").show();
	
	jQuery("#botao_cancelar").click(function() {
		jQuery("#opcoes_aposta").hide();
		
		pedirParaApostar(fichasDisponiveis, valorDaApostaMinima, pote);
	});
	jQuery("#botao_cancelar").show();
}

/**
 * (Mtodo chamado pelo Applet) Pergunta se o jogador quer cobrir a aposta feita pelo computador.
 * @param fichasDisponiveis O nmero de fichas disponveis.
 * @param fichasNecessariasParaCobrir O nmero de fichas necessrias para cobrir a aposta.
 * @param pote O valor do pote atual.
 */
function perguntarSeQuerCobrir (fichasDisponiveis, fichasNecessariasParaCobrir, pote) {
	// Perguntar e colocar um boto para confirmar
	jQuery("input[id^='botao_']").hide();
	jQuery("input[id^='botao_']").unbind("click");
	
	var allin = false;
	var texto = "<b>Voc deseja cobrir a aposta?</b><br />";
	
	if (parseInt(fichasNecessariasParaCobrir) > 1) texto += "So necessrias " + fichasNecessariasParaCobrir + " fichas";
	else texto += " necessria " + fichasNecessariasParaCobrir + " ficha";
	
	if (parseInt(fichasDisponiveis) <= parseInt(fichasNecessariasParaCobrir)) {
		texto += "<br /> Voc ter que ir all-in!";
		allin = true;
	}
	
	log("#nome_jogador_inferior", texto, "bottom", TEMPO_MENSAGEM_COBRIR);
	
	var botao = allin?"#botao_allin":"#botao_cobrir";
	jQuery(botao).click(function() {
		jQuery("input[id^='botao_']").unbind("click");
		jQuery("#opcoes_botoes").fadeOut("slow");
		
		// colocando as fichas
		if (allin) {
			fichasInferior = 0;
			fichasApostadasInferior += parseInt(fichasDisponiveis);
		} else {
			fichasInferior -= parseInt(fichasNecessariasParaCobrir);
			fichasApostadasInferior += parseInt(fichasNecessariasParaCobrir);
		}
		
		apresentarFichas("#fichas_inferior", fichasInferior);
		apresentarFichas("#aposta_inferior", fichasApostadasInferior);
		
		setTimeout(function() {
			document.getElementById("applet_poquer").getInterfaceHTML().cobrir(true);
		}, TEMPO_ESPERA);
	});
	jQuery(botao).show();
	
	jQuery("#botao_fugir").click(function() {
		jQuery("input[id^='botao_']").unbind("click");
		jQuery("#opcoes_botoes").fadeOut("slow");
		
		setTimeout(function() {
			document.getElementById("applet_poquer").getInterfaceHTML().cobrir(false);
		}, TEMPO_ESPERA);
	});
	jQuery("#botao_fugir").show();
	
	jQuery("#opcoes_botoes").fadeIn("slow");
}

/**
 * (Mtodo chamado pelo Applet) Informa se o computador cobriu a aposta ou no.
 * @param resposta Se o computador cobriu ("true") ou no ("false").
 * @param fichasDisponiveis O nmero de fichas atualmente disponveis.
 * @param fichasNecessariasParaCobrir O nmero de fichas necessrias para cobrir.
 */
function cobrir(resposta, fichasDisponiveis, fichasNecessariasParaCobrir) {
	if (resposta == "true") {
		log("#nome_jogador_superior", "Computador cobre a aposta.", "top");
		
		if (parseInt(fichasDisponiveis) - parseInt(fichasNecessariasParaCobrir) < 0) {
			// all-in
			fichasSuperior = 0;
			fichasApostadasSuperior += parseInt(fichasDisponiveis);
		} else {
			fichasSuperior = parseInt(fichasDisponiveis) - parseInt(fichasNecessariasParaCobrir);
			fichasApostadasSuperior += parseInt(fichasNecessariasParaCobrir);
		}
		
		// animando as fichas
		apresentarFichas("#fichas_superior", fichasSuperior);
		apresentarFichas("#aposta_superior", fichasApostadasSuperior);
	} else {
		// Se no cobriu, ento acabou a mo
		log("#nome_jogador_superior", "Computador no cobre a aposta.", "top");
	}
	
	sleep(TEMPO_ESPERA);
}

/**
 * (Mtodo chamado pelo Applet) Mostra as cartas do computador.
 * @param cartas As cartas do computador.
 */
function mostrar(cartas) {
	var vetorCartas = cartas.split("|");
	
	for (var i = 0; i < vetorCartas.length - 1; i++) {
		jQuery("#carta_superior" + (i + 1)).rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
			// No  possvel usar o "i" aqui dentro...
			var posicao = parseInt(jQuery(this).attr("id").replace("carta_superior", "")) - 1;
			jQuery(this).attr("src", CARTAS[vetorCartas[posicao]].src);
		}});
	}
	
	// s diferenciando a ltima carta por causa do ACK
	jQuery("#carta_superior" + (vetorCartas.length)).rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
		jQuery(this).attr("src", CARTAS[vetorCartas[vetorCartas.length - 1]].src);
	}, complete: function() {sleep(TEMPO_ESPERA);}});
}

/**
 * (Mtodo chamado pelo Applet) Avisa que o jogador ganhou ou perdeu a mo.
 * @param posicao A posio do jogador ("SUPERIOR" ou "INFERIOR").
 * @param resultado Se o jogador em questo ganhou (1), empatou (0) ou perdeu (-1).
 * @param fichasDisponiveis O nmero de fichas que o jogador tem agora disponvel.
 * @param pote O pote que foi jogado.
 */
function avisarGanhouMao(posicao, resultado, fichasDisponiveis, pote) {
	if (posicao == "SUPERIOR") {
		fichasSuperior = parseInt(fichasDisponiveis);
		fichasApostadasSuperior = 0;
	} else {
		fichasInferior = parseInt(fichasDisponiveis);
		fichasApostadasInferior = 0;
	}
	
	numeroDeAvisos++;
	
	if (numeroDeAvisos == 2) {
		// tirando as fichas do jogo
		jQuery("#aposta_inferior").children("img[.tooltip]").fadeOut("slow", function() {
			jQuery(this).remove();
		});
		jQuery("#aposta_superior").children("img[.tooltip]").fadeOut("slow", function() {
			jQuery(this).remove();
		});
		
		apresentarFichas("#fichas_superior", fichasSuperior);
		apresentarFichas("#fichas_inferior", fichasInferior);
		if (parseInt(resultado) == 0) {
			log("#mesa_central", "<div class='mensagemFim'><br /><b>As mos empataram</b><br /><br /></div>", "null");
		} else if ((posicao == "SUPERIOR" && parseInt(resultado) > 0) || (posicao == "INFERIOR" && parseInt(resultado) < 0)){
			log("#mesa_central", "<div class='mensagemFim'><b>Computador ganhou a mo.</b><br />Pote: " + pote + " fichas.</div>", "null", TEMPO_MENSAGEM_VENCEU);
		} else {
			log("#mesa_central", "<div class='mensagemFim'><b>" + nomeJogador + " ganhou a mo.</b><br />Pote: " + pote + " fichas.</div>", "null", TEMPO_MENSAGEM_VENCEU);
		}
		numeroDeAvisos = 0;
		
		setTimeout(function() {
			limparMesa();
			sleep(TEMPO_ESPERA);
		}, 2*TEMPO_ESPERA);
	} else {
		sleep(0); // s para dar o ACK
	}
}

/**
 * Limpa a mesa, tirando todas as cartas.
 */
function limparMesa() {
	// Tirando as cartas que estavam visveis
	jQuery("img[id^='carta_virada']").fadeOut("slow", function() {
		jQuery(this).remove();
	});
	jQuery("img[id^='carta_superior']").fadeOut("slow");
	jQuery("img[id^='carta_inferior']").fadeOut("slow");
	
	mesaVazia = 0;
}

/**
 * (Mtodo chamado pelo Applet) Avisa que o jogo acabou.
 * @param usuarioGanhou Se o usurio ganhou (true) ou no (false).
 */
function avisarFimDoJogo(usuarioGanhou) {
	habilitaMascara();
	
	var mensagem;
	if (usuarioGanhou == "true") {
		mensagem = "Voc ganhou o jogo!!!"

		// soltando fogos
		for(var i = 0; i < NUMERO_DE_FOGOS; i++) {
			setTimeout(function() {
				createFirework(20, 50, 4, null, 10 + Math.random()*70, 10 + Math.random()*70, null, null, Math.random()>0.5, true);
			}, Math.random()*100 + (i*800));
		}
	} else {
		mensagem = "Voc perdeu o jogo..."
	}
	apresentarMensagemFim(mensagem);
}

/**
 * Apresenta a mensagem de fim de jogo
 * @param mensagem A mensagem de fim de jogo.
 */
function apresentarMensagemFim(mensagem) {
	mensagem = "<div class='mensagemFim'>" +
					"<br /><div class='tituloMensagemFim'>" + mensagem + "</div>" +
					"<br />" +
					"Deseja jogar novamente?<br /><br />" +
					"<input type='button' value='Sim' onClick='javascript:reiniciar();'/>" +
					"&nbsp;" +
					"<input type='button' value='No' onClick='javascript:fim();'/>" +
					"<br />" +
				"</div>";
	
	jQuery("#mesa_central").showBalloon({
		contents: mensagem,
		showDuration: "slow",
		showAnimation: function(d) { this.fadeIn(d); },
		hideDuration: "slow",
		hideAnimation: function(d) { this.fadeOut(d); },
		position: "null",
		css: {
			border: "solid 3px #6e9e77",
			opacity: "1.0",
			backgroundColor: "#ffffff",
			zIndex: "9900",
			color: "#000000"
		}
	});
}

/**
 * Reiniciando o jogo
 */
function reiniciar() {
	jQuery("#mesa_central").hideBalloon();
	desabilitaMascara();
	
	setTimeout(function(){ iniciarJogo(); }, TEMPO_BALAO);
}

/**
 * Termina o jogo e volta para o menu inicial.
 */
function fim() {
	jQuery("#mesa_central").hideBalloon();
	desabilitaMascara();
	
	setTimeout(function() { apresentarMenu(); }, TEMPO_BALAO);
}

/**
 * Apresenta a quantidade de fichas um determinado lugar.
 * @param id O elemento onde as fichas sero colocadas.
 * @param fichas O nmero de fichas a ser colocado em tal elemento.
 */
function apresentarFichas(id, fichas) {
	jQuery(id).empty();
	var figuras;
	
	for (figuras = fichas; figuras >= 5; figuras -= 5) {
		jQuery(id).append("<img class='tooltip' src='" + FICHAS["5"].src + "' width='" + FICHAS["5"].width + "' height='" + FICHAS["5"].height + "' title='" + fichas + "' />");
	}
	
	if (figuras == 0) {
		jQuery(id).append(" "); // s para ocupar o espao
	} else if (figuras == 1) {
		jQuery(id).append("<img src='images/1-ficha.png' class='tooltip' width='43' height='30' title='" + fichas + "' />");
	} else if (figuras == 2) {
		jQuery(id).append("<img src='images/2-ficha.png' class='tooltip' width='43' height='36' title='" + fichas + "' />");
	} else if (figuras == 3) {
		jQuery(id).append("<img src='images/3-ficha.png' class='tooltip' width='43' height='42' title='" + fichas + "' />");
	} else if (figuras == 4) {
		jQuery(id).append("<img src='images/4-ficha.png' class='tooltip' width='43' height='48' title='" + fichas + "' />");
	}
	
	tooltip();
}

/**
 * No d para simplesmente fazer um loop para gastar tempo. Isso trava o Browser.
 * A soluo  usar um ACK... No muito elegante, mas funcional.
 */
function sleep(time) {
	if (time == 0) {
		document.getElementById("applet_poquer").getInterfaceHTML().ack();
	} else {
		setTimeout(function() {
			document.getElementById("applet_poquer").getInterfaceHTML().ack();
		}, time);
	}
}

/**
 * Apresenta uma mensagem de erro do Java.
 * @param mensagem A mensagem a ser apresentada.
 */
function erro(mensagem) {
	if (omitirErros) return;
	
	teveErro = true;
	jQuery("#erro_mensagem").text(mensagem);
	jQuery("#erro").dialog("open");
}

/**
 * Escreve uma mensagem de log.
 * @param id O elemento onde o log deve ser apresentado
 * @param mensagem A mensagem a ser apresentada nesse elemento.
 * @param posicao A posio ("top", "bottom", "left", "right", "top left", "top right",
 * 		"bottom left" e "bottom right") relativa ao elemento onde o log  apresentado em
 *		que o balo ser apresentado.
 */
function log(id, mensagem, posicao, tempo) {
	tempo = tempo | TEMPO_BALAO;
	jQuery(id).showBalloon({
		contents: mensagem,
		showDuration: "slow",
		showAnimation: function(d) { this.fadeIn(d); },
		hideDuration: "slow",
		hideAnimation: function(d) { this.fadeOut(d); },
		minLifetime: tempo,
		position: posicao,
		css: {
			border: 'solid 1px #444444',
			backgroundColor: '#eeeeee',
			opacity: "1.0",
			color: '#000000'
		}
	}).hideBalloon();
}