/**
 * Tooltip script 
 * powered by jQuery (http://www.jquery.com)
 * 
 * written by Alen Grakalic (http://cssglobe.com)
 * 
 * for more info visit http://cssglobe.com/post/1695/easiest-tooltip-and-image-preview-using-jquery
 * 
 * Adapted by Fabio Levy Siqueira: added the exists function.
 *
 */

/**
 * Adicionando o mtodo "exists" no jQuery
 */
jQuery.fn.exists = function() {
	return this.length > 0;
}

this.tooltip = function(){	
	/* CONFIG */		
		xOffset = 10;
		yOffset = 20;		
		// these 2 variable determine popup's distance from the cursor
		// you might want to adjust to get the right result		
	/* END CONFIG */		
	jQuery("img.tooltip").hover(function(e){
		if (!jQuery("#tooltip").exists()) {
			this.t = this.title;
			this.title = "";
			jQuery("body").append("<p id='tooltip'>"+ this.t +"</p>");
			jQuery("#tooltip")
				.css("top",(e.pageY - xOffset) + "px")
				.css("left",(e.pageX + yOffset) + "px")
				.fadeIn("fast");
		}
    });
	jQuery("img.tooltip").mouseout(function(e){
		if (jQuery("#tooltip").exists()) {
			this.title = this.t;
			jQuery("#tooltip").remove();
		}
    });
	
	jQuery("img.tooltip").mousemove(function(e){
		if (jQuery("#tooltip").exists()) {
			jQuery("#tooltip")
				.css("top",(e.pageY - xOffset) + "px")
				.css("left",(e.pageX + yOffset) + "px");
		}
	});			
};