/**
 * Funes especficas do jogo de Texas Hold'em
 * @author FLevy
 * @date 11/02/2012
 */
 
 /**
 * (Mtodo chamado pelo Applet) Apresenta o flop.
 * @param carta1 A primeira carta do flop.
 * @param carta2 A segunda carta do flop.
 * @param carta3 A terceira carta do flop.
 */
function flop(carta1, carta2, carta3) {
	jQuery("#carta_virada1").rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
		jQuery(this).attr("src", CARTAS[carta1].src);
	}});
	jQuery("#carta_virada2").rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
		jQuery(this).attr("src", CARTAS[carta2].src);
	}});
	jQuery("#carta_virada3").rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
		jQuery(this).attr("src", CARTAS[carta3].src);
	}, complete: function() {sleep(TEMPO_ESPERA);}});
}

/**
 * (Mtodo chamado pelo Applet) Apresenta o turn.
 * @param carta A carta do turn.
 */
function turn(carta) {
	jQuery("#carta_virada4").rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
		jQuery(this).attr("src", CARTAS[carta].src);
	}, complete: function() {sleep(TEMPO_ESPERA);}});
}

/**
 * (Mtodo chamado pelo Applet) Apresenta o river.
 * @param carta A carta do river.
 */
function river(carta) {
	jQuery("#carta_virada5").rotate3Di(180, TEMPO_FLIP, {sideChange: function() {
		jQuery(this).attr("src", CARTAS[carta].src);
	}, complete: function() {sleep(TEMPO_ESPERA);}});
}