package br.usp.poli.java.ihc;

/*
Copyright (C) 2012 Fbio Levy Siqueira (levy.siqueira@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * Representa uma implementao de Jogo de Poquer para ser usada pela
 * interface grfica.<br />
 * 
 * @author FLevy
 */
public interface Jogo {
	/**
	 * Informa o nome do autor da implementao do jogo de poquer.
	 * @return O nome do autor.
	 */
	public String nomeDoAutor();
}
